<template>
  <v-container>
    <v-row cols="12" align="center"  justify="center">
      <v-col id="chart-year" lg="6" md="6" sm="6" cols="12">
        <apexchart
          type="bar"
          width="90%"
          height="400"
          ref="chart"
          :options="chartOptions"
          :series="series">
        </apexchart>
      </v-col>
      <v-col
        id="chart-quarter"
        lg="6"
        md="6"
        sm="6"
        cols="12">
        <div v-show="this.showChart">
          <apexchart
            type="bar"
            width="90%"
            height="400"
            ref="chartQuarter"
            :options="chartOptionsQuarter"
            :series="seriesQuarter">
          </apexchart>
        </div>
        <div v-show="!this.showChart">
          <v-alert
            text
            prominent
            color="primary"
            elevation="1"
            icon="mdi-cloud-alert"
          >
            Seleccione un elemento del gráfico de barras para mostrar su distribución de la calificación.
          </v-alert>
        </div>
      </v-col>
    </v-row>
  </v-container>
</template>
<script>
export default {
  name: 'DynamicLoadedChart',
  props: {
    'scoreXReason': { type: Array },
    'scoreDetails': { type: Array },
  },
  data() {
    return {
      showChart: false,
      colors: [],
      seriesUpdated: [],
      indexAdded: [],
      secondSeries: this.scoreDetails,
      series: this.scoreXReason,
      chartOptions: {
        colors: ['#B9F6CA', '#C1E1FF', '#FAE198', '#B6BFCE', '#C1BBF5', '#FAFE3B', '#FF00C7'],
        stroke: {
          show: true,
          width: 1,
          colors: ['#ffffff'],
        },
        states: {
          active: {
            allowMultipleDataPointsSelection: true,
            filter: {
              type: 'darken',
              value: 1,
            },
          },
        },
        chart: {
          width: '80%',
          type: 'bar',
          events: {
            dataPointSelection: (e, chart, opts) => {
              // If we Select new Point
              if (opts.selectedDataPoints[0].length > this.indexAdded.length) {
                this.showChart = true;
                this.updateQuarterChart(chart, opts.selectedDataPoints[0], 'add');
              } else {
              // In other case UnSelect
                this.updateQuarterChart(chart, opts.selectedDataPoints[0], 'delete');
              }
            },
          },
        },
        plotOptions: {
          bar: {
            columnWidth: '80%',
            distributed: true,
            borderRadius: 10,
          },
        },
        dataLabels: {
          enabled: true,
          style: {
            fontSize: '10px',
            colors: ['#999999'],
          },
        },
        legend: {
          show: false,
        },
        xaxis: {
          categories: ['Motivo 1', 'Motivo 2', 'Motivo 3', 'Motivo 4', 'Motivo 5'],
          labels: {
            style: {
              fontSize: '12px',
            },
          },
          title: {
            text: 'Motivo de consulta',
            style: {
              color: '#909399',
            },
          },
        },
        yaxis: {
          title: {
            text: 'Puntuación efectuada',
            style: {
              color: '#909399',
            },
          },
        },
      },
      seriesQuarter: [{
        data: [],
      }],
      chartOptionsQuarter: {
        chart: {
          id: 'barQuarter',
          type: 'bar',
          stacked: true,
        },
        plotOptions: {
          bar: {
            horizontal: true,
            borderRadius: 10,
          },
        },
        legend: {
          show: false,
        },
        grid: {
          yaxis: {
            lines: {
              show: false,
            },
          },
        },
        yaxis: {
          title: {
            text: 'Puntuación',
            style: {
              color: '#909399',
            },
          },
          labels: {
            show: true,
          },
        },
        xaxis: {
          title: {
            text: 'Cantidad de encuestas efectuadas',
            style: {
              color: '#909399',
            },
          },
          categories: ['5.0', '4.0', '3.0', '2.0', '1.0'],
        },
        title: {
          text: 'Distribución de la puntuación',
          align: 'center',
          style: {
            fontSize: '16px',
            fontWeight: '700',
            fontFamily: 'Montserrat',
            color: '#505050',
          },
        },
      },
    };
  },
  methods: {
    updateQuarterChart(sourceChart, selectedDataPoints, type) {
      // If SELECT new one.
      if (type === 'add') {
        const index = selectedDataPoints[selectedDataPoints.length - 1];
        this.indexAdded.push(index);
        this.seriesUpdated.push({
          name: this.chartOptions.xaxis.categories[index],
          data: this.secondSeries[index],
        });
        this.colors.push(this.chartOptions.colors[index]);
      }
      // If UNSELECT.
      let deleteIndex;
      if (type === 'delete') {
        this.indexAdded.forEach((item) => {
          if (!selectedDataPoints.includes(item)) {
            deleteIndex = item;
          }
        });
        this.seriesUpdated.forEach((item, i) => {
          if (item.name === this.chartOptions.xaxis.categories[deleteIndex]) {
            this.indexAdded.splice(i, 1);
            this.seriesUpdated.splice(i, 1);
            this.colors.splice(i, 1);
          }
        });
      }
      this.$refs.chartQuarter.updateOptions({
        series: this.seriesUpdated,
        colors: this.colors,
      });
    },
    updateChartDynamic(secondReport, motivos) {
      this.seriesUpdated = [];
      this.indexAdded = [];
      this.colors = [];
      this.chartOptions.xaxis.categories = motivos.map(motivo => motivo.motivo);
      this.$refs.chart.updateOptions({
        series: secondReport.scoreXReason,
        xaxis: {
          categories: motivos.map(motivo => motivo.motivo),
        },
      });
      this.$refs.chartQuarter.updateOptions({
        series: [],
        colors: this.colors,
      });
      this.secondSeries = secondReport.scoreDetails;
      // This is used to set selectedDataPoints in 0.
      this.$refs.chart.chart.w.globals.selectedDataPoints = [];
      // this.showChart = false;
    },
  },
};
</script>
<style scoped>
.labelStyle{
  font-family: "Montserrat", sans-serif;
  font-size: 16px;
  color: #505050;
  font-weight: 700;
  text-align: center;
}
</style>
